package jp.allabout.android;

import java.util.List;


import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.Window;
import android.view.WindowManager;
import android.view.ViewGroup.LayoutParams;

public class Camera extends Activity implements SensorEventListener, LocationListener{
	private CameraPreview mPreview;
	private CameraView mMview;
	private LocationManager lm;
	private SensorManager mSensorManager;
	private boolean mRegisteredSensor;
	private double soutaikaku;
	private double tatekaku;
	private Sensor accel;
	private Sensor orient;
	double my_latitude;
	double my_longitude;
	double my_direction;
	double my_distance;
	
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // ZT֌W
        mSensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
        mRegisteredSensor = false;
        // P[V}l[W̐ݒ
        lm = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
        lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
        
        // ^Cg
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        // Jr[pSurfaceView𐶐Zbg
        mPreview = new CameraPreview(this);
        setContentView(mPreview);
        
        mMview = new CameraView(this);
        
        addContentView(mMview, new LayoutParams
                (LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));

    }
    
    public void onAccuracyChanged(Sensor arg0, int arg1) {
		// TODO Auto-generated method stub
		
	}

	public void onSensorChanged(SensorEvent event) {
		// TODO Auto-generated method stub
		if (event.sensor.getType() == Sensor.TYPE_ORIENTATION) {
			// p̕ω
			my_direction = event.values[0]; //x@
			// 0=North, 90=East, 180=South, 270=West
			soutaikaku = my_direction - CommonLib.getDirection(my_latitude, my_longitude, 
					TargetInformation.INSTANCE.latitude, 
					TargetInformation.INSTANCE.longitude);
			mMview.round = soutaikaku;
			mMview.pitch = event.values[1];
			mMview.roll = event.values[2];
			
			mMview.invalidate();
		}
	}
	
	@Override
    protected void onResume() {
     List<Sensor> sensors = mSensorManager.getSensorList(Sensor.TYPE_ORIENTATION);
     
     if (sensors.size() > 0) {
         Sensor sensor = sensors.get(0);
         mRegisteredSensor = mSensorManager.registerListener(this,
             sensor,
             SensorManager.SENSOR_DELAY_FASTEST);
     }  
     super.onResume();
    }
	
	 @Override
     protected void onPause() {
         if (mRegisteredSensor) {
             mSensorManager.unregisterListener(this);
             mRegisteredSensor = false;
         }
         super.onPause();
     }
	 
	 @Override
     protected void onStop() {
         // unregister listener
      mSensorManager.unregisterListener(this);
         super.onStop();
     }

	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		my_latitude = location.getLatitude();
		my_longitude = location.getLongitude();
		
		my_distance = CommonLib.getDistance(my_latitude, my_longitude, 
				TargetInformation.INSTANCE.latitude, TargetInformation.INSTANCE.longitude);
		soutaikaku = my_direction - CommonLib.getDirection(my_latitude, my_longitude, 
				TargetInformation.INSTANCE.latitude, 
				TargetInformation.INSTANCE.longitude);
		mMview.round = soutaikaku;
		mMview.distance = my_distance;
		
		
		// ĕ`
		mMview.invalidate();
	}

	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
		
	}
}