package jp.allabout.android;

public class CommonLib {
	private CommonLib() { }
	public static double getDistance(double my_latitude, double my_longitude,
			double target_latitude, double target_longitude) {
		double rad = Math.acos(Math.sin(my_latitude)*Math.sin(target_latitude) 
				+ Math.cos(my_latitude)*Math.cos(target_latitude)
					*Math.cos(my_longitude-target_longitude));
		return 6370 * rad * 1000;	
	}
	public static double getDirection(double my_latitude, double my_longitude,
			double target_latitude, double target_longitude) {
		double Y = Math.cos(target_longitude) * Math.sin(target_latitude - my_latitude);
		double X = Math.cos(my_longitude) * Math.sin(target_longitude) - Math.sin(my_longitude) * Math.cos(target_longitude) * Math.cos(target_latitude - my_latitude);
		double arad = Math.atan2(Y, X);
		return arad * 180 /  Math.PI + Math.PI;
	
	}
}
